core/urls.py
from django.urls import path, include

from core import views

urlpatterns = [
    path('login/', views.LoginPage.as_view(), name = 'login'),
    path('logout/', views.LogoutPage.as_view(), name = 'logout'),
    path('', views.LandingPage.as_view(), name='landing'),
    # Admin
    path('admin-home/', views.AdminHome.as_view(), name = 'admin-home'),
    path('user/', views.CreateUser.as_view(), name = 'user'),
    path('user/<int:pk>/', views.EditUser.as_view(), name = 'edit-user'),
    path('user/<int:pk>/delete/', views.DeleteUser.as_view(), name = 'delete-user'),
]

lister/urls.py
from django.urls import path, include

from lister import views

urlpatterns = [
    path('', views.ListerHome.as_view(), name = 'home'),
    path('settings/', views.ListerSettingsPage.as_view(), name = 'settings'),
    path('list/', views.CreateList.as_view(), name = 'create-list'),
    path('list/<int:pk>/', views.ViewList.as_view(), name = 'view-list'),
    path('list/<int:pk>/edit/', views.EditList.as_view(), name = 'edit-list'),
    path('list/<int:pk>/share/', views.ShareList.as_view(), name = 'share-list'),
    path('list/<int:pk>/delete/', views.DeleteList.as_view(), name = 'delete-list'),
    path('list/item/<int:pk>/toggle/', views.ToggleListItem.as_view(), name = 'toggle-item'),
    path('list/item/<int:pk>/delete/', views.DeleteItem.as_view(), name = 'delete-item'),
]

server/urls.py
"""cerrax-cloud URL Configuration
"""
from django.contrib import admin
from django.urls import path, include
from django.shortcuts import redirect

def redirect_view(request, uri, root=''):
    return redirect(root+uri, permanent=True)

urlpatterns = [

    # admin interface !! FOR DEV ONLY - NOT PRODUCTION !!
    path('admin/', admin.site.urls),

    # main website (Cerrax.com)
    path('', include(('website.urls', 'website'), namespace='website')),

    # Cerrax Cloud apps
    path('cloud/', include(('core.urls', 'core'), namespace='core')),
    path('cloud/lister/', include(('lister.urls', 'lister'), namespace='lister')),
    path('cloud/docket/', include(('docket.urls', 'docket'), namespace='docket')),
    path('cloud/arkham/', include(('arkham.urls', 'arkham'), namespace='arkham')),
    # redirect lister, since it it used frequently
    # deprecate this path and eventually disable it
    path('lister/<path:uri>', redirect_view, {'root':'/cloud/lister/'}),
    
]

lister/models.py
from django.db import models

from core.models import CoreModel, CerraxUser
from core.utils import Sort, Sorting

#-== @h1
# Lister Models
#-== /lister.models.py
#________________________________________



##########################################
#-== @class
class ListSorting(Sorting):
	#-== Sortings available for the /List model.

	DATA = [
		Sort('name', 'Sort by Name'),
		Sort('created', 'Sort by Created'),
	]



##########################################
#-== @class
class ListItemSorting(Sorting):
	#-== Sortings available for the /ListItem model.

	DATA = [
		Sort('name', 'Sort by Name'),
		Sort('created', 'Sort by Created'),
		Sort('checked', 'Sort by Marked'),
	]



##########################################
#-== @class
class ListerSettings(CoreModel):
	#-== User-specific settings to tailor the experience.

	# -== *Model Fields:*
	# @deflist
	# user: the /CerraxUser the settings belong to
	# purge_old_items_days: number of days after a /ListItem
	#						has been marked that it will remain in the list.
	#						Once this age has been surpassed,
	#						the ListItem is permanently deleted
	# auto_delete_empty_list: a boolean indicating if an empty list
	#						should be deleted automatically
	# list_sorting: the default sorting of the list

	user = models.ForeignKey(CerraxUser, on_delete=models.CASCADE)
	purge_old_items_days = models.IntegerField(default=7)
	auto_delete_empty_list = models.BooleanField(default=True)
	list_sorting = models.CharField(max_length=30, choices=ListSorting.choices(), default='created')

	#-== @note
	# The /list_sorting is automatically changed and stored
	# whenever the user touches the sort buttons in the button bar.
	# This ensures that the entries always appear
	# in the same order that the user last left them.

	def __str__(self):
		return '{} settings'.format(self.user)



##########################################
#-== @class
class List(CoreModel):
	#-== The main object that /ListItem objects are contained within.

	#-== *Model Fields:*
	# @deflist
	# user: the /CerraxUser the list belongs to
	# name: the name of the list
	# show_checked: a boolean indicating if marked items should appear in the list
	# sorting: the default sorting of items in the list

	user = models.ForeignKey(CerraxUser, on_delete=models.CASCADE)
	name = models.CharField(max_length=100)
	show_checked = models.BooleanField(default=False)
	sorting = models.CharField(max_length=30, choices=ListItemSorting.choices(), default='created')

	#-== @note
	# The /show_checked and /sorting are automatically changed and stored
	# whenever the user touches tthose buttons in the button bar.
	# This ensures that the entries always appear
	# exactly the way that the user last left them.

	def __str__(self):
		return "{} - {}".format(self.user, self.name)



##########################################
#-== @class
class ListItem(CoreModel):
	#-== An individual item to be marked in a /List .

	#-== *Model Fields:*
	# @deflist
	# parent: the /List object this item belongs to
	# name: the name of the item
	# checked: the datetime that the item was checked.
	#			Set to /None when it has been unchecked.

	parent = models.ForeignKey(List, on_delete=models.CASCADE)
	name = models.CharField(max_length=100, blank=True, null=True)
	checked = models.DateTimeField(blank=True, null=True)

	def __str__(self):
		return '{} - {}'.format(self.parent, self.name)


# LIST SHARE SETTINGS
# Links non-owner users to a list and
# stores their settings and permissions
##########################################
#-== @class
class ListShare(CoreModel):
	#-== Links non-owner users to a list and
	# stores their settings and permissions.

	#-== *Model Fields:*
	# @deflist
	# parent: the /List object this share refers to
	# user: the /CerraxUser the list is being shared with
	# view_items: a blooean which indicates if the /user
	#				can see the items in a list.
	#				This should always be set to /True
	# edit_items: a boolean which indicates if the /user
	#				can add/mark/delete items from the list
	# edit_list: a boolean which indicates if the /user
	#				can change the name of the list,
	#				or delete the list

	parent = models.ForeignKey(List, on_delete=models.CASCADE)
	user = models.ForeignKey(CerraxUser, on_delete=models.CASCADE)
	view_items = models.BooleanField(default=True)
	edit_items = models.BooleanField(default=True)
	edit_list = models.BooleanField(default=False)
	show_checked = models.BooleanField(default=False)
	sorting = models.CharField(max_length=30, choices=ListItemSorting.choices(), default='created')

	def __str__(self):
		return '{} - share with {}'.format(self.parent, self.user)

lister/views.py
import logging
import datetime

from django.utils import timezone
from django.views import View
from django.core.exceptions import ObjectDoesNotExist, ValidationError
from django.http import HttpResponse, HttpResponseRedirect, HttpResponseServerError
from django.shortcuts import render
from django.urls import reverse_lazy
from django.db.models import Q
from django.db.models.functions import Lower

from core.models import Apps, AppPermissions, CerraxUser
from core.views import BaseView, CrudMixin
from lister.models import ListSorting, ListItemSorting, ListerSettings, List, ListItem, ListShare


#-== @h1
# Lister Views
#-== /lister.views.py
#________________________________________


##########################################
#-== @class
class ListerBase(BaseView):
	#-== Sets the /app_permission for all derived views as /Apps.LISTER .

	app_permission = Apps.LISTER

	# ----------------------------------------------------
	#-== @method
	def is_valid_user(self, list, user):
		#-== Check if the user is the owner of the list or a superuser
		# @params
		# list: the /List object to check against
		# user: the /CerraxUser object to compare
		# @returns
		# /True if the /user is valid for the /list, /False if not.
		# @note
		# A superuser ( /user.is_superuser ) will always return /True from this method.

		return user == list.user or user.is_superuser

	# ----------------------------------------------------
	#-== @method
	def has_list_permissions(self, list, user, list_settings):
		#-== Check if the user has permission to edit the list
		# @params
		# list: the /List object to check against
		# user: the /CerraxUser object to compare
		# list_settings: the /ListShare object for the list and /user
		# @returns
		# /True if the /user has valid permissions for the /list, /False if not.
		# @note
		# A superuser ( /user.is_superuser ) will always return /True from this method.

		return user == list.user \
			or user.is_superuser \
			or (user != list.user
				and list_settings != list
				and list_settings.edit_list)

	# ----------------------------------------------------
	#-== @method
	def has_list_edit(self, user, list_settings):
		#-== Check if the user has permission to edit the list
		# @params
		# user: the /CerraxUser object to compare
		# list_settings: the /ListShare object for the list and /user
		# @returns
		# /True if the /user has the edit permission for the /list, /False if not.
		# @note
		# A superuser ( /user.is_superuser ) will always return /True from this method.

		return list_settings.edit_items or user.is_superuser



##########################################
#-== @class
class ListerHome(ListerBase):
	#-== Shows all of the lists available to the user.
	# This includes not only lists that the user has created,
	# but also any lists that have been shared with them.

	page_title = 'Lister'
	back_url = reverse_lazy('core:landing')
	button_bar_left = ListSorting.button_bar_display()
	button_bar_right = [
		{'display': '+ New List', 'url': reverse_lazy('lister:create-list') },
		{'display': 'Settings', 'url': reverse_lazy('lister:settings') },
	]

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the lists available to the user.
	# @params
	# sort: the field name by which the lists should be sorted

	def get(self, request, *args, **kwargs):
		sorting = request.GET.get('sort', None)

		user_settings, created = ListerSettings.objects.get_or_create(user=request.user)
		if sorting:
			user_settings.list_sorting = sorting
			user_settings.save()
		sorting = user_settings.list_sorting

		# housekeeping
		self.purge_old_items(request.user, user_settings)

		listlist = List.objects.filter(Q(user=request.user) | Q(listshare__user=request.user))
		if sorting:
			listlist = listlist.order_by(Lower(sorting)).distinct()

		self.context['listlist'] = listlist
		return render(request, 'lister/home.html', self.context)


	# ----------------------------------------------------
	#-== @method
	def purge_old_items(self, user, settings):
		#-== Every time the view is requested, this method checks
		# for old /ListItem objects and empty /List objects,
		# and deletes them according to the user's settings.
		# @params
		# user: the /CerraxUser viewing the page
		# settings: the /ListerSettings of the /user

		purge_days = settings.purge_old_items_days
		if purge_days >= 0:
			purge_threshold = timezone.now() - datetime.timedelta(days=purge_days)
			old_items = ListItem.objects.filter(parent__user=user, checked__lt=purge_threshold)
			num_deleted = old_items.delete()[0]
			if num_deleted > 0:
				self.logger.info('Purged {} items older than {} days'.format(num_deleted, purge_days))
		if settings.auto_delete_empty_list:
			non_empty_lists = ListItem.objects.filter(parent__user=user).values_list('parent__id').distinct()
			empty_lists = List.objects.filter(user=user).exclude(pk__in=non_empty_lists)
			num_deleted = empty_lists.delete()[0]
			if num_deleted > 0:
				self.logger.info('Purged {} empty lists'.format(num_deleted))



##########################################
#-== @class
class ListerSettingsPage(ListerBase):
	#-== A page to adjust the /ListerSettings of the user.

	page_title = 'Settings'
	back_url = reverse_lazy('lister:home')

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the user's current settings within the /lister\/settings.html template.

	def get(self, request, *args, **kwargs):
		user_settings, created = ListerSettings.objects.get_or_create(user=request.user)
		self.context['auto_delete_empty_list'] = user_settings.auto_delete_empty_list
		days = user_settings.purge_old_items_days
		self.context['purge_options'] = [
			{ 'value': 0, 'display': 'immediately', 'selected': days == 0 },
			{ 'value': 1, 'display': 'after 1 day', 'selected': days == 1  },
			{ 'value': 3, 'display': 'after 3 days', 'selected': days == 3  },
			{ 'value': 7, 'display': 'after 1 week', 'selected': days == 7  },
			{ 'value': 30, 'display': 'after 1 month', 'selected': days == 30  },
			{ 'value': 90, 'display': 'after 3 months', 'selected': days == 90  },
			{ 'value': -1, 'display': 'never', 'selected': days == -1  },
		]

		return render(request, 'lister/settings.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Adjust the settings based on the data received from the form.
	# @params
	# purge_old_items_days: the number of days a marked item
	#						remains in a list before being deleted
	# auto_delete_empty_list: a boolean indicating if empty lists
	#						should automatically be deleted

	def post(self, request, *args, **kwargs):
		user_settings, created = ListerSettings.objects.get_or_create(user=request.user)
		purge_days = request.POST.get('purge_old_items_days', None)
		if purge_days is not None:
			user_settings.purge_old_items_days = purge_days
		auto_delete = request.POST.get('auto_delete_empty_list', False)
		if auto_delete:
			user_settings.auto_delete_empty_list = True
		else:
			user_settings.auto_delete_empty_list = False
		user_settings.save()

		return self.redirect('lister:home')



##########################################
#-== @class
class CreateList(ListerBase):
	#-== Create a new list.

	page_title = 'New List'
	back_url = reverse_lazy('lister:home')

	# ----------------------------------------------------
	#-== @method
	# GET
	#-== Display the /lister\/create-list.html template.

	def get(self, request, *args, **kwargs):
		return render(request, 'lister/create-list.html', self.context)

	# ----------------------------------------------------
	#-== @method
	# POST
	#-== Create the /List and /ListItem objects.
	# On success, redirects to /ListerHome .
	# @params
	# name: the name of the list *(required)*
	# show_checked: if this parameter is present, regardless of its value,
	#				the list will display marked items
	# item1: the first item name to display in the list
	# item2: the second item name to display in the list
	# item3: the third item name to display in the list
	# item4: the fourth item name to display in the list
	# item5: the fifth item name to display in the list
	# item6: the sixth item name to display in the list
	# item7: the seventh item name to display in the list
	# item8: the eighth item name to display in the list
	# item9: the ninth item name to display in the list
	# item10: the tenth item name to display in the list

	def post(self, request, *args, **kwargs):
		name = request.POST.get('name', None)
		show_checked = request.POST.get('show_checked', None) is not None

		if not name:
			self.log_error('You must name the list.')

		list_items = []
		for i in range(10):
			item = request.POST.get('item'+str(i+1), None)
			if item:
				list_items.append(item)

		if not list_items:
			self.log_error('You must include at least 1 list item.')

		if self.context['errors']:
			return render(request, 'lister/create-list.html', self.context)

		newlist = List.objects.create(user=request.user, name=name, show_checked=show_checked)
		for item in list_items:
			ListItem.objects.create(parent=newlist, name=item)

		if not self.context['errors']:
			return self.redirect('lister:home')
		else:
			return render(request, 'lister/create-list.html', self.context)



##########################################
#-== @class
class ViewList(ListerBase):
	#-== Display a list and allow adding items
	# and marking items when they are completed.

	page_title = 'View List'
	back_url = reverse_lazy('lister:home')
	button_bar_left = ListItemSorting.button_bar_display()

	# ----------------------------------------------------
	#-== @method
	def display_list(self, user, thelist, sorting=None, show_checked=None):
		#-== Determines the settings for displaying the list and then
		# prepares the context to deliver to the template.

		list_settings = thelist
		if user != thelist.user:
			try:
				list_settings = ListShare.objects.get(parent=thelist, user=user)

lister/templates/lister/create-list.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<form id="create-list-form" method="POST">
	{% csrf_token %}
	<label>Name</label>
	<input type="text" name="name" value="{{ name }}" />

	<div class="checkbox-box">
		<input type="checkbox" name="show_checked" value="true" {% if show_checked %}checked{% endif %} />
		<label>Show marked items</label>
	</div>

	<div>List items</div>

	<input type="text" name="item1" value="{{ item1 }}" />
	<input type="text" name="item2" value="{{ item2 }}" />
	<input type="text" name="item3" value="{{ item3 }}" />
	<input type="text" name="item4" value="{{ item4 }}" />
	<input type="text" name="item5" value="{{ item5 }}" />
	<input type="text" name="item6" value="{{ item6 }}" />
	<input type="text" name="item7" value="{{ item7 }}" />
	<input type="text" name="item8" value="{{ item8 }}" />
	<input type="text" name="item9" value="{{ item9 }}" />
	<input type="text" name="item10" value="{{ item10 }}" />

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

lister/templates/lister/delete-list.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div id="list">
	<form id="delete-list" method="POST">
	<label>Are you sure you want to <br/> delete this list?</label>
	<div class="delete-user-name">
		{{ list_name }}
	</div>
	<div class="delete-user-username">
		{{ num_items }}
	</div>
		{% csrf_token %}
		<input type="submit" value="Yes" class="warning-color" />
	</form>
	<div class="list padded">
		<a href="{% url 'lister:home' %}" class="list">
			<button>No</button>
		</a>
	</div>
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

lister/templates/lister/edit-list.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<script>
	function checkbox_click(url) {
		window.location=url;
	}
</script>
<div class="list">
	<form id="edit-list-form" method="POST">
		{% csrf_token %}
		<label>Name</label>
		<input type="text" name="name" value="{{ name }}" />

		<div class="checkbox-box">
			<input type="checkbox" name="show_checked" value="true" {% if show_checked %}checked{% endif %} />
			<label>Show marked items</label>
		</div>

		<input type="submit" value="Save" />
	</form>
	{% for item in list_items %}
	<form class="list-item-form" method="POST" action="{% url 'lister:delete-item' item.id %}">
		{% csrf_token %}
		<input type="checkbox" {% if item.checked %}checked{% endif %} disabled />
		<label>{{ item.name }}</label>
		<input class="warning-color" type="submit" value="X" {% if not items_editable %}disabled{% endif %}/>
	</form>
	{% endfor %}
	<div class="list-spacer"></div>
		<div class="list padded">
		<a href="{% url 'lister:delete-list' listid %}" class="list">
			<button class="warning-color">Delete List</button>
		</a>
	</div>
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

lister/templates/lister/home.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div class="list">
	{% for item in listlist %}
	<a href="{% url 'lister:view-list' item.id %}">
		<div class="list-item">{{ item.name }}</div>
	</a>
	{% endfor %}
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

lister/templates/lister/settings.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<form id="settings-form" method="POST">
	{% csrf_token %}
	<div class="inline-label-input">
		<label>Delete marked items </label>
		<select name="purge_old_items_days">
			{% for opt in purge_options %}
			<option value="{{ opt.value }}" {% if opt.selected %}selected{% endif %}>{{ opt.display }}</option>
			{% endfor %}
		</select>
	</div>

	<div class="checkbox-box">
		<input type="checkbox" name="auto_delete_empty_list" value="true" {% if auto_delete_empty_list %}checked{% endif %} />
		<label>Automatically delete empty lists</label>
	</div>

	<input type="submit" value="Save" />
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</form>
{% endblock %}

lister/templates/lister/share-list.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<div id="list">
	<form id="share-list" method="POST">
	<div class="delete-user-name">
		{{ list_name }}
	</div>
	<div class="delete-user-username">
		{{ num_items }}
	</div>
		{% csrf_token %}
	<div class="checkbox-box">
		<label></label>
		<div class="checkbox-column-header">View Items</div>
		<div class="checkbox-column-header">Edit Items</div>
		<div class="checkbox-column-header">Edit List</div>
	</div>
	<div class="list-spacer"></div>
	{% for item in user_list %}
	<div class="checkbox-box">
		<label>{{ item.user.first_name }} {{ item.user.last_name }}</label>
		<input type="checkbox" name="{{ item.user.id }}-view_items" value="true" {% if item.view_items %}checked{% endif %} />
		<input type="checkbox" name="{{ item.user.id }}-edit_items" value="true" {% if item.edit_items %}checked{% endif %} />
		<input type="checkbox" name="{{ item.user.id }}-edit_list" value="true" {% if item.edit_list %}checked{% endif %} />
	</div>
	{% endfor %}
		<input type="submit" value="Save" />
	</form>
	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}

lister/templates/lister/view-list.html
{% extends 'core/base.html' %}
{% load static %}


{% block content %}
<script>
	function checkbox_click(url) {
		window.location=url;
	}
</script>
<div class="list">
	<!-- ADD NEW ITEM -->
	<form class="list-item-form" method="POST">
		{% csrf_token %}
		<input type="submit" value="+" {% if not items_editable %}disabled{% endif %} />
		<input type="text" name="newitem" value=""
			{% if not items_editable %}disabled{% endif %} autofocus />
	</form>
	<div class="list-spacer"></div>

	<!-- ITEM LIST -->
	{% for item in list_items %}
	{% if items_editable %}
	<a href="{% url 'lister:toggle-item' item.id %}">
	{% endif %}
		<div class="checkbox-box">
		<a href="{% url 'lister:toggle-item' item.id %}">
			<input class="no-pointer-events" type="checkbox" name="{{item.id}}" value="true"
				{% if item.checked %}checked{% endif %} {% if not items_editable %}disabled{% endif %} />
		</a>
		<label>{{ item.name }}</label>
	</div>
	{% if items_editable %}
	
	{% endif %}
	{% endfor %}

	<!-- BOTTOM MARGIN -->
	<!-- This is needed to malke sure the browser
		doesn't cover up the bottom of the page with controls. -->
	<div class="list-bottom-margin"></div>
</div>
{% endblock %}